// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from marti_nav_msgs:msg/Path.idl
// generated code does not contain a copyright notice

#ifndef MARTI_NAV_MSGS__MSG__DETAIL__PATH__TRAITS_HPP_
#define MARTI_NAV_MSGS__MSG__DETAIL__PATH__TRAITS_HPP_

#include "marti_nav_msgs/msg/detail/path__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'points'
#include "marti_nav_msgs/msg/detail/path_point__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const marti_nav_msgs::msg::Path & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: points
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.points.size() == 0) {
      out << "points: []\n";
    } else {
      out << "points:\n";
      for (auto item : msg.points) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: in_reverse
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "in_reverse: ";
    value_to_yaml(msg.in_reverse, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const marti_nav_msgs::msg::Path & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<marti_nav_msgs::msg::Path>()
{
  return "marti_nav_msgs::msg::Path";
}

template<>
inline const char * name<marti_nav_msgs::msg::Path>()
{
  return "marti_nav_msgs/msg/Path";
}

template<>
struct has_fixed_size<marti_nav_msgs::msg::Path>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<marti_nav_msgs::msg::Path>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<marti_nav_msgs::msg::Path>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // MARTI_NAV_MSGS__MSG__DETAIL__PATH__TRAITS_HPP_
