// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_nav_msgs:msg/RouteSpeed.idl
// generated code does not contain a copyright notice
#include "marti_nav_msgs/msg/detail/route_speed__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `id`
#include "rosidl_runtime_c/string_functions.h"

bool
marti_nav_msgs__msg__RouteSpeed__init(marti_nav_msgs__msg__RouteSpeed * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_nav_msgs__msg__RouteSpeed__fini(msg);
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__init(&msg->id)) {
    marti_nav_msgs__msg__RouteSpeed__fini(msg);
    return false;
  }
  // distance
  // speed
  return true;
}

void
marti_nav_msgs__msg__RouteSpeed__fini(marti_nav_msgs__msg__RouteSpeed * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // id
  rosidl_runtime_c__String__fini(&msg->id);
  // distance
  // speed
}

bool
marti_nav_msgs__msg__RouteSpeed__are_equal(const marti_nav_msgs__msg__RouteSpeed * lhs, const marti_nav_msgs__msg__RouteSpeed * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->id), &(rhs->id)))
  {
    return false;
  }
  // distance
  if (lhs->distance != rhs->distance) {
    return false;
  }
  // speed
  if (lhs->speed != rhs->speed) {
    return false;
  }
  return true;
}

bool
marti_nav_msgs__msg__RouteSpeed__copy(
  const marti_nav_msgs__msg__RouteSpeed * input,
  marti_nav_msgs__msg__RouteSpeed * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // id
  if (!rosidl_runtime_c__String__copy(
      &(input->id), &(output->id)))
  {
    return false;
  }
  // distance
  output->distance = input->distance;
  // speed
  output->speed = input->speed;
  return true;
}

marti_nav_msgs__msg__RouteSpeed *
marti_nav_msgs__msg__RouteSpeed__create()
{
  marti_nav_msgs__msg__RouteSpeed * msg = (marti_nav_msgs__msg__RouteSpeed *)malloc(sizeof(marti_nav_msgs__msg__RouteSpeed));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_nav_msgs__msg__RouteSpeed));
  bool success = marti_nav_msgs__msg__RouteSpeed__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_nav_msgs__msg__RouteSpeed__destroy(marti_nav_msgs__msg__RouteSpeed * msg)
{
  if (msg) {
    marti_nav_msgs__msg__RouteSpeed__fini(msg);
  }
  free(msg);
}


bool
marti_nav_msgs__msg__RouteSpeed__Sequence__init(marti_nav_msgs__msg__RouteSpeed__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_nav_msgs__msg__RouteSpeed * data = NULL;
  if (size) {
    data = (marti_nav_msgs__msg__RouteSpeed *)calloc(size, sizeof(marti_nav_msgs__msg__RouteSpeed));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_nav_msgs__msg__RouteSpeed__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_nav_msgs__msg__RouteSpeed__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_nav_msgs__msg__RouteSpeed__Sequence__fini(marti_nav_msgs__msg__RouteSpeed__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_nav_msgs__msg__RouteSpeed__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_nav_msgs__msg__RouteSpeed__Sequence *
marti_nav_msgs__msg__RouteSpeed__Sequence__create(size_t size)
{
  marti_nav_msgs__msg__RouteSpeed__Sequence * array = (marti_nav_msgs__msg__RouteSpeed__Sequence *)malloc(sizeof(marti_nav_msgs__msg__RouteSpeed__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_nav_msgs__msg__RouteSpeed__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_nav_msgs__msg__RouteSpeed__Sequence__destroy(marti_nav_msgs__msg__RouteSpeed__Sequence * array)
{
  if (array) {
    marti_nav_msgs__msg__RouteSpeed__Sequence__fini(array);
  }
  free(array);
}

bool
marti_nav_msgs__msg__RouteSpeed__Sequence__are_equal(const marti_nav_msgs__msg__RouteSpeed__Sequence * lhs, const marti_nav_msgs__msg__RouteSpeed__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marti_nav_msgs__msg__RouteSpeed__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marti_nav_msgs__msg__RouteSpeed__Sequence__copy(
  const marti_nav_msgs__msg__RouteSpeed__Sequence * input,
  marti_nav_msgs__msg__RouteSpeed__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marti_nav_msgs__msg__RouteSpeed);
    marti_nav_msgs__msg__RouteSpeed * data =
      (marti_nav_msgs__msg__RouteSpeed *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marti_nav_msgs__msg__RouteSpeed__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          marti_nav_msgs__msg__RouteSpeed__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marti_nav_msgs__msg__RouteSpeed__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
